diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/propagation/model/channel-condition-model.cc ns-3.42/src/propagation/model/channel-condition-model.cc
--- ns-3.41/src/propagation/model/channel-condition-model.cc	2024-02-09 14:44:08.453794000 -0800
+++ ns-3.42/src/propagation/model/channel-condition-model.cc	2024-05-29 15:29:47.160073800 -0700
@@ -20,14 +20,60 @@
 
 #include "ns3/boolean.h"
 #include "ns3/double.h"
+#include "ns3/geocentric-constant-position-mobility-model.h"
 #include "ns3/log.h"
 #include "ns3/mobility-model.h"
 #include "ns3/node.h"
+#include "ns3/pointer.h"
 #include "ns3/simulator.h"
 #include "ns3/string.h"
 
 #include <cmath>
 
+namespace
+{
+
+/// NTN Dense Urban LOS probabilities from table 6.6.1-1 of 3GPP 38.811
+const std::map<int, double> DenseUrbanLOSProb{
+    {10, {28.2}},
+    {20, {33.1}},
+    {30, {39.8}},
+    {40, {46.8}},
+    {50, {53.7}},
+    {60, {61.2}},
+    {70, {73.8}},
+    {80, {82.0}},
+    {90, {98.1}},
+};
+
+/// NTN Urban LOS probabilities from table 6.6.1-1 of 3GPP 38.811
+const std::map<int, double> UrbanLOSProb{
+    {10, {24.6}},
+    {20, {38.6}},
+    {30, {49.3}},
+    {40, {61.3}},
+    {50, {72.6}},
+    {60, {80.5}},
+    {70, {91.9}},
+    {80, {96.8}},
+    {90, {99.2}},
+};
+
+/// NTN Suburban LOS probabilities from table 6.6.1-1 of 3GPP 38.811
+const std::map<int, double> SuburbanRuralLOSProb{
+    {10, {78.2}},
+    {20, {86.9}},
+    {30, {91.9}},
+    {40, {92.9}},
+    {50, {93.5}},
+    {60, {94.0}},
+    {70, {94.9}},
+    {80, {95.2}},
+    {90, {99.8}},
+};
+
+} // namespace
+
 namespace ns3
 {
 
@@ -537,6 +583,29 @@
     return key;
 }
 
+std::tuple<double, double>
+ThreeGppChannelConditionModel::GetQuantizedElevationAngle(Ptr<const MobilityModel> a,
+                                                          Ptr<const MobilityModel> b)
+{
+    Ptr<MobilityModel> aMobNonConst = ConstCast<MobilityModel>(a);
+    Ptr<MobilityModel> bMobNonConst = ConstCast<MobilityModel>(b);
+
+    // check if aMob and bMob are of type GeocentricConstantPositionMobilityModel
+    auto aNTNMob = DynamicCast<GeocentricConstantPositionMobilityModel>(aMobNonConst);
+    auto bNTNMob = DynamicCast<GeocentricConstantPositionMobilityModel>(bMobNonConst);
+    NS_ASSERT_MSG(aNTNMob && bNTNMob,
+                  "Mobility Models need to be of type Geocentric for NTN scenarios");
+
+    double elevAngle = aNTNMob->GetElevationAngle(bNTNMob);
+    // Round the elevation angle into a two-digits integer between 10 and 90, as specified in
+    // Sec. 6.6.1, 3GPP TR 38.811 v15.4.0
+    int elevAngleQuantized = (elevAngle < 10) ? 10 : round(elevAngle / 10) * 10;
+    NS_ASSERT_MSG((elevAngleQuantized >= 10) && (elevAngleQuantized <= 90),
+                  "Invalid elevation angle!");
+
+    return std::make_tuple(elevAngle, elevAngleQuantized);
+};
+
 // ------------------------------------------------------------------------- //
 
 NS_OBJECT_ENSURE_REGISTERED(ThreeGppRmaChannelConditionModel);
@@ -829,4 +898,100 @@
     return pLos;
 }
 
+// ------------------------------------------------------------------------- //
+
+NS_OBJECT_ENSURE_REGISTERED(ThreeGppNTNDenseUrbanChannelConditionModel);
+
+TypeId
+ThreeGppNTNDenseUrbanChannelConditionModel::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::ThreeGppNTNDenseUrbanChannelConditionModel")
+                            .SetParent<ThreeGppChannelConditionModel>()
+                            .SetGroupName("Propagation")
+                            .AddConstructor<ThreeGppNTNDenseUrbanChannelConditionModel>();
+    return tid;
+}
+
+double
+ThreeGppNTNDenseUrbanChannelConditionModel::ComputePlos(Ptr<const MobilityModel> a,
+                                                        Ptr<const MobilityModel> b) const
+{
+    // Compute the LOS probability (see 3GPP TR 38.811, Table 6.6.1-1).
+    // The elevation angle is first quantized to one of the reference angles.
+    auto [elevAngle, quantizedElevAngle] = GetQuantizedElevationAngle(a, b);
+    return DenseUrbanLOSProb.at(quantizedElevAngle);
+}
+
+// ------------------------------------------------------------------------- //
+
+NS_OBJECT_ENSURE_REGISTERED(ThreeGppNTNUrbanChannelConditionModel);
+
+TypeId
+ThreeGppNTNUrbanChannelConditionModel::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::ThreeGppNTNUrbanChannelConditionModel")
+                            .SetParent<ThreeGppChannelConditionModel>()
+                            .SetGroupName("Propagation")
+                            .AddConstructor<ThreeGppNTNUrbanChannelConditionModel>();
+    return tid;
+}
+
+double
+ThreeGppNTNUrbanChannelConditionModel::ComputePlos(Ptr<const MobilityModel> a,
+                                                   Ptr<const MobilityModel> b) const
+{
+    // Compute the LOS probability (see 3GPP TR 38.811, Table 6.6.1-1).
+    // The elevation angle is first quantized to one of the reference angles.
+    auto [elevAngle, quantizedElevAngle] = GetQuantizedElevationAngle(a, b);
+    return UrbanLOSProb.at(quantizedElevAngle);
+}
+
+// ------------------------------------------------------------------------- //
+
+NS_OBJECT_ENSURE_REGISTERED(ThreeGppNTNSuburbanChannelConditionModel);
+
+TypeId
+ThreeGppNTNSuburbanChannelConditionModel::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::ThreeGppNTNSuburbanChannelConditionModel")
+                            .SetParent<ThreeGppChannelConditionModel>()
+                            .SetGroupName("Propagation")
+                            .AddConstructor<ThreeGppNTNSuburbanChannelConditionModel>();
+    return tid;
+}
+
+double
+ThreeGppNTNSuburbanChannelConditionModel::ComputePlos(Ptr<const MobilityModel> a,
+                                                      Ptr<const MobilityModel> b) const
+{
+    // Compute the LOS probability (see 3GPP TR 38.811, Table 6.6.1-1).
+    // The elevation angle is first quantized to one of the reference angles.
+    auto [elevAngle, quantizedElevAngle] = GetQuantizedElevationAngle(a, b);
+    return SuburbanRuralLOSProb.at(quantizedElevAngle);
+}
+
+// ------------------------------------------------------------------------- //
+
+NS_OBJECT_ENSURE_REGISTERED(ThreeGppNTNRuralChannelConditionModel);
+
+TypeId
+ThreeGppNTNRuralChannelConditionModel::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::ThreeGppNTNRuralChannelConditionModel")
+                            .SetParent<ThreeGppChannelConditionModel>()
+                            .SetGroupName("Propagation")
+                            .AddConstructor<ThreeGppNTNRuralChannelConditionModel>();
+    return tid;
+}
+
+double
+ThreeGppNTNRuralChannelConditionModel::ComputePlos(Ptr<const MobilityModel> a,
+                                                   Ptr<const MobilityModel> b) const
+{
+    // Compute the LOS probability (see 3GPP TR 38.811, Table 6.6.1-1).
+    // The elevation angle is first quantized to one of the reference angles.
+    auto [elevAngle, quantizedElevAngle] = GetQuantizedElevationAngle(a, b);
+    return SuburbanRuralLOSProb.at(quantizedElevAngle);
+}
+
 } // end namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/propagation/model/channel-condition-model.h ns-3.42/src/propagation/model/channel-condition-model.h
--- ns-3.41/src/propagation/model/channel-condition-model.h	2024-02-09 14:44:08.453794000 -0800
+++ ns-3.42/src/propagation/model/channel-condition-model.h	2024-05-29 15:29:47.160073800 -0700
@@ -24,6 +24,7 @@
 #include "ns3/random-variable-stream.h"
 #include "ns3/vector.h"
 
+#include <map>
 #include <unordered_map>
 
 namespace ns3
@@ -483,6 +484,27 @@
      */
     int64_t AssignStreams(int64_t stream) override;
 
+    /**
+     * Computes and quantizes the elevation angle to a two-digits integer in [10, 90].
+     * Asserts that the provided mobility models are of the expected type, i.e.,
+     * GeocentricConstantPositionMobilityModel, and that the quantized
+     * angle is in the expected range [10, 90].
+     *
+     * \param a mobility model
+     * \param b mobility model
+     * \return the tuple [elevation angle, quantized elevation angle] between a and b
+     */
+    static std::tuple<double, double> GetQuantizedElevationAngle(Ptr<const MobilityModel> a,
+                                                                 Ptr<const MobilityModel> b);
+
+    /**
+     * \brief Computes the 2D distance between two 3D vectors
+     * \param a the first 3D vector
+     * \param b the second 3D vector
+     * \return the 2D distance between a and b
+     */
+    static double Calculate2dDistance(const Vector& a, const Vector& b);
+
   protected:
     void DoDispose() override;
 
@@ -497,14 +519,6 @@
         INVALID
     };
 
-    /**
-     * \brief Computes the 2D distance between two 3D vectors
-     * \param a the first 3D vector
-     * \param b the second 3D vector
-     * \return the 2D distance between a and b
-     */
-    static double Calculate2dDistance(const Vector& a, const Vector& b);
-
     Ptr<UniformRandomVariable> m_uniformVar; //!< uniform random variable
 
   private:
@@ -781,6 +795,154 @@
      */
     double ComputePlos(Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const override;
 };
+
+/**
+ * \ingroup propagation
+ *
+ * \brief Computes the channel condition for the NTN Dense Urban Scenario
+ *
+ * Computes the channel condition following the specifications for the
+ * Indoor Mixed Office scenario reported in Table 6.6.1-1 of 3GPP TR 38.811
+ */
+class ThreeGppNTNDenseUrbanChannelConditionModel : public ThreeGppChannelConditionModel
+{
+  public:
+    /**
+     *  Register this type.
+     *  \return The object TypeId.
+     */
+    static TypeId GetTypeId();
+
+    /**
+     * Constructor for the ThreeGppNTNDenseUrbanChannelConditionModel class
+     */
+    ThreeGppNTNDenseUrbanChannelConditionModel() = default;
+
+    /**
+     * Destructor for the ThreeGppNTNDenseUrbanChannelConditionModel class
+     */
+    ~ThreeGppNTNDenseUrbanChannelConditionModel() override = default;
+
+  private:
+    /**
+     * \copydoc ThreeGppChannelConditionModel::ComputePlos
+     *
+     * Compute the LOS probability as specified in Table 6.6.1-1 of 3GPP TR 38.811
+     * for the NTN Dense Urban scenario.
+     */
+    double ComputePlos(Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const override;
+};
+
+/**
+ * \ingroup propagation
+ *
+ * \brief Computes the channel condition for the NTN Urban Scenario
+ *
+ * Computes the channel condition following the specifications for the
+ * Indoor Mixed Office scenario reported in Table 6.6.1-1 of 3GPP TR 38.811
+ */
+class ThreeGppNTNUrbanChannelConditionModel : public ThreeGppChannelConditionModel
+{
+  public:
+    /**
+     *  Register this type.
+     *  \return The object TypeId.
+     */
+    static TypeId GetTypeId();
+
+    /**
+     * Constructor for the ThreeGppNTNUrbanChannelConditionModel class
+     */
+    ThreeGppNTNUrbanChannelConditionModel() = default;
+
+    /**
+     * Destructor for the ThreeGppNTNUrbanChannelConditionModel class
+     */
+    ~ThreeGppNTNUrbanChannelConditionModel() override = default;
+
+  private:
+    /**
+     * \copydoc ThreeGppChannelConditionModel::ComputePlos
+     *
+     * Compute the LOS probability as specified in Table 6.6.1-1 of 3GPP TR 38.811
+     * for the NTN Urban scenario.
+     */
+    double ComputePlos(Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const override;
+};
+
+/**
+ * \ingroup propagation
+ *
+ * \brief Computes the channel condition for the NTN Suburban Scenario
+ *
+ * Computes the channel condition following the specifications for the
+ * Indoor Mixed Office scenario reported in Table 6.6.1-1 of 3GPP TR 38.811
+ */
+class ThreeGppNTNSuburbanChannelConditionModel : public ThreeGppChannelConditionModel
+{
+  public:
+    /**
+     *  Register this type.
+     *  \return The object TypeId.
+     */
+    static TypeId GetTypeId();
+
+    /**
+     * Constructor for the ThreeGppNTNSuburbanChannelConditionModel class
+     */
+    ThreeGppNTNSuburbanChannelConditionModel() = default;
+
+    /**
+     * Destructor for the ThreeGppNTNSuburbanChannelConditionModel class
+     */
+    ~ThreeGppNTNSuburbanChannelConditionModel() override = default;
+
+  private:
+    /**
+     * \copydoc ThreeGppChannelConditionModel::ComputePlos
+     *
+     * Compute the LOS probability as specified in Table 6.6.1-1 of 3GPP TR 38.811
+     * for the NTN Suburban scenario.
+     */
+    double ComputePlos(Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const override;
+};
+
+/**
+ * \ingroup propagation
+ *
+ * \brief Computes the channel condition for the NTN Rural Scenario
+ *
+ * Computes the channel condition following the specifications for the
+ * Indoor Mixed Office scenario reported in Table 6.6.1-1 of 3GPP TR 38.811
+ */
+class ThreeGppNTNRuralChannelConditionModel : public ThreeGppChannelConditionModel
+{
+  public:
+    /**
+     *  Register this type.
+     *  \return The object TypeId.
+     */
+    static TypeId GetTypeId();
+
+    /**
+     * Constructor for the ThreeGppNTNRuralChannelConditionModel class
+     */
+    ThreeGppNTNRuralChannelConditionModel() = default;
+
+    /**
+     * Destructor for the ThreeGppNTNRuralChannelConditionModel class
+     */
+    ~ThreeGppNTNRuralChannelConditionModel() override = default;
+
+  private:
+    /**
+     * \copydoc ThreeGppChannelConditionModel::ComputePlos
+     *
+     * Compute the LOS probability as specified in Table 6.6.1-1 of 3GPP TR 38.811
+     * for the NTN Rural scenario.
+     */
+    double ComputePlos(Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const override;
+};
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/propagation/model/jakes-process.h ns-3.42/src/propagation/model/jakes-process.h
--- ns-3.41/src/propagation/model/jakes-process.h	2024-02-09 14:44:08.457794000 -0800
+++ ns-3.42/src/propagation/model/jakes-process.h	2024-05-29 15:29:47.160073800 -0700
@@ -31,7 +31,7 @@
 class JakesPropagationLossModel;
 
 /**
- * \ingroup fading
+ * \ingroup propagation
  *
  * \brief Implementation for a single path Stationary Jakes propagation loss model.
  *
@@ -45,9 +45,8 @@
  * \f[ X_s(t) = \frac{2}{\sqrt{M}}\sum_{n=1}^{M}\sin(\psi_n)\cos(\omega_d t\cos(\alpha_n)+\phi_n)\f]
  * with
  * \f[ \alpha_n = \frac{2\pi n - \pi + \theta}{4M},  n=1,2, \ldots,M\f]
- * where
- *\f$\theta\f$, \f$\phi\f$, and \f$\psi_n\f$ are statically independent and uniformly distributed
- *over \f$[-\pi, \pi)\f$ for all \f$n\f$.
+ * where \f$\theta\f$, \f$\phi\f$, and \f$\psi_n\f$ are
+ * statically independent and uniformly distributed over \f$[-\pi, \pi)\f$ for all \f$n\f$.
  *
  *
  * [1] Y. R. Zheng and C. Xiao, "Simulation Models With Correct
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/propagation/model/propagation-loss-model.cc ns-3.42/src/propagation/model/propagation-loss-model.cc
--- ns-3.41/src/propagation/model/propagation-loss-model.cc	2024-02-09 14:44:08.457794000 -0800
+++ ns-3.42/src/propagation/model/propagation-loss-model.cc	2024-05-29 15:29:47.160073800 -0700
@@ -161,9 +161,10 @@
                                    &FriisPropagationLossModel::GetFrequency),
                 MakeDoubleChecker<double>())
             .AddAttribute("SystemLoss",
-                          "The system loss",
+                          "The system loss (linear factor >= 1, not in dB)",
                           DoubleValue(1.0),
-                          MakeDoubleAccessor(&FriisPropagationLossModel::m_systemLoss),
+                          MakeDoubleAccessor(&FriisPropagationLossModel::SetSystemLoss,
+                                             &FriisPropagationLossModel::GetSystemLoss),
                           MakeDoubleChecker<double>())
             .AddAttribute("MinLoss",
                           "The minimum value (dB) of the total loss, used at short ranges.",
@@ -181,6 +182,7 @@
 void
 FriisPropagationLossModel::SetSystemLoss(double systemLoss)
 {
+    NS_ABORT_MSG_UNLESS(systemLoss >= 1, "System loss less than 1 corresponds to gain");
     m_systemLoss = systemLoss;
 }
 
@@ -308,9 +310,10 @@
                                    &TwoRayGroundPropagationLossModel::GetFrequency),
                 MakeDoubleChecker<double>())
             .AddAttribute("SystemLoss",
-                          "The system loss",
+                          "The system loss (linear factor >= 1, not in dB)",
                           DoubleValue(1.0),
-                          MakeDoubleAccessor(&TwoRayGroundPropagationLossModel::m_systemLoss),
+                          MakeDoubleAccessor(&TwoRayGroundPropagationLossModel::SetSystemLoss,
+                                             &TwoRayGroundPropagationLossModel::GetSystemLoss),
                           MakeDoubleChecker<double>())
             .AddAttribute(
                 "MinDistance",
@@ -334,6 +337,7 @@
 void
 TwoRayGroundPropagationLossModel::SetSystemLoss(double systemLoss)
 {
+    NS_ABORT_MSG_UNLESS(systemLoss >= 1, "System loss less than 1 corresponds to gain");
     m_systemLoss = systemLoss;
 }
 
@@ -530,6 +534,8 @@
     double distance = a->GetDistanceFrom(b);
     if (distance <= m_referenceDistance)
     {
+        NS_LOG_DEBUG("distance=" << distance << "m, reference-attenuation=" << -m_referenceLoss
+                                 << "dB, no further attenuation");
         return txPowerDbm - m_referenceLoss;
     }
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/propagation/model/propagation-loss-model.h ns-3.42/src/propagation/model/propagation-loss-model.h
--- ns-3.41/src/propagation/model/propagation-loss-model.h	2024-02-09 14:44:08.457794000 -0800
+++ ns-3.42/src/propagation/model/propagation-loss-model.h	2024-05-29 15:29:47.160073800 -0700
@@ -271,9 +271,11 @@
      */
     void SetFrequency(double frequency);
     /**
-     * \param systemLoss (dimension-less)
+     * \param systemLoss (linear factor, dimension-less)
      *
      * Set the system loss used by the Friis propagation model.
+     * Value should be greater than or equal to 1; the default of 1
+     * corresponds to no system loss.
      */
     void SetSystemLoss(double systemLoss);
 
@@ -295,7 +297,7 @@
      */
     double GetFrequency() const;
     /**
-     * \returns the current system loss (dimension-less)
+     * \returns the current system loss (linear factor, dimension-less)
      */
     double GetSystemLoss() const;
 
@@ -321,7 +323,7 @@
 
     double m_lambda;     //!< the carrier wavelength
     double m_frequency;  //!< the carrier frequency
-    double m_systemLoss; //!< the system loss
+    double m_systemLoss; //!< the system loss (linear factor)
     double m_minLoss;    //!< the minimum loss
 };
 
@@ -376,9 +378,11 @@
     void SetFrequency(double frequency);
 
     /**
-     * \param systemLoss (dimension-less)
+     * \param systemLoss (linear factor, dimension-less)
      *
      * Set the system loss used by the TwoRayGround propagation model.
+     * Value should be greater than or equal to 1; the default of 1
+     * corresponds to no system loss.
      */
     void SetSystemLoss(double systemLoss);
     /**
@@ -399,7 +403,7 @@
     double GetFrequency() const;
 
     /**
-     * \returns the current system loss (dimension-less)
+     * \returns the current system loss (linear factor, dimension-less)
      */
     double GetSystemLoss() const;
     /**
@@ -431,7 +435,7 @@
 
     double m_lambda;       //!< the carrier wavelength
     double m_frequency;    //!< the carrier frequency
-    double m_systemLoss;   //!< the system loss
+    double m_systemLoss;   //!< the system loss (linear factor)
     double m_minDistance;  //!< minimum distance for the model
     double m_heightAboveZ; //!< antenna height above the node's Z coordinate
 };
